#include <windows.h>
#include <d2d1.h>
#pragma comment(lib,"d2d1.lib")

LRESULT _stdcall WndProc (HWND hWnd, UINT message, WPARAM wParam, LPARAM lParam );

int _stdcall WinMain (HINSTANCE hInstance, HINSTANCE hPrevInstance, LPSTR lpCmdLine, int nCmdShow)
{
	WNDCLASS wc;
	wc.style = CS_OWNDC;
	wc.lpfnWndProc = WndProc;
	wc.cbClsExtra = 0;
	wc.cbWndExtra = 0;
	wc.hInstance = hInstance;
	wc.hIcon = LoadIcon(NULL, IDI_APPLICATION);
	wc.hCursor = LoadCursor(NULL, IDC_ARROW);
	wc.hbrBackground = (HBRUSH)(6);
	wc.lpszMenuName = 0;
	wc.lpszClassName = L"class";

	RegisterClass(&wc);
	HWND hWnd = CreateWindow(
	            L"class",
	            L"Direct2D init",
	            WS_OVERLAPPEDWINDOW,100,100,600,600,
	            NULL,NULL,hInstance,NULL);

	ID2D1Factory* factory = NULL;
	D2D1CreateFactory(D2D1_FACTORY_TYPE_SINGLE_THREADED,&factory);

	ID2D1HwndRenderTarget* rt = NULL;
	factory->CreateHwndRenderTarget(D2D1::RenderTargetProperties(),
	         D2D1::HwndRenderTargetProperties(hWnd,D2D1::SizeU(500,500)),&rt);

	ID2D1SolidColorBrush* rbrush = NULL;
	rt->CreateSolidColorBrush(D2D1::ColorF(D2D1::ColorF::DarkRed),&rbrush);

	ShowWindow(hWnd,nCmdShow);
	UpdateWindow(hWnd);
	MSG msg;

	while(true)
	{
		if(PeekMessage(&msg,0,0,0,PM_REMOVE))
		{
			if(msg.message == WM_QUIT)
				break;  
			TranslateMessage(&msg);
			DispatchMessage(&msg);
		}
		rt->BeginDraw();
		rt->Clear(D2D1::ColorF(D2D1::ColorF::White));
		rt->DrawRectangle(D2D1::RectF(200.0f,200.0f,300.0f,300.0f),rbrush,100.0f,NULL);
		rt->EndDraw();

	}
	if (rbrush != NULL)
		rbrush->Release();
	if (rt != NULL)
		rt->Release();
	if (factory != NULL)
		factory->Release();

	return 0;
}

LRESULT _stdcall WndProc( HWND hWnd, UINT msg, WPARAM wParam, LPARAM lParam)
{
	switch(msg)
	{
		case WM_DESTROY:
			PostQuitMessage(0);
		return 0;
		default:
			return DefWindowProc(hWnd,msg,wParam,lParam);
	}
}